﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using System.Drawing;
using System.Windows.Forms;

namespace WinGrid_ExpandAllButton_CS
{
    public class ExpandAllButtonCreationFilter : IUIElementCreationFilter
    {
        void IUIElementCreationFilter.AfterCreateChildElements(UIElement parent)
        {
            if (parent is RowSelectorHeaderUIElement)
            {
                // Get the Rows collection associated with the columnChooserButtonUIElement. We need this
                // for context. 
                RowsCollection rows = parent.GetContext(typeof(RowsCollection)) as RowsCollection;

                ExpandCollapseButtonUIElement expandAllButton = new ExpandCollapseButtonUIElement(parent, rows, true);
                ExpandCollapseButtonUIElement collapseAllButton = new ExpandCollapseButtonUIElement(parent, rows, false);

                int buttonWidth = SystemInformation.VerticalScrollBarWidth + 2;
                int buttonHeight = parent.Rect.Height;

                // Determine the other rect values. These are the same for each button, except for the X.
                int x = parent.Rect.X;
                int y = parent.Rect.Y;

                // Place the ExpandAll button.
                expandAllButton.Rect = new Rectangle(x, y, buttonWidth, buttonHeight);
                parent.ChildElements.Add(expandAllButton);

                // Shift the x position by one button width. 
                x += buttonWidth;

                // Place the CollapseAll button.
                collapseAllButton.Rect = new Rectangle(x, y, buttonWidth, buttonHeight);
                parent.ChildElements.Add(collapseAllButton);
            }
        }

        bool IUIElementCreationFilter.BeforeCreateChildElements(UIElement parent)
        {
            // Do nothing.
            return false;
        }
    }
}
