﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using System.Drawing;
using System.IO;
using System.Diagnostics;

namespace WinGrid_ExpandAllButton_CS
{
    public class ExpandCollapseButtonUIElement : ImageAndTextButtonUIElement
    {
        [ThreadStatic]
        private static Image expandImage;        

        [ThreadStatic]
        private static Image collapseImage;

        private bool expand;
        private RowsCollection rows;

        public ExpandCollapseButtonUIElement(UIElement parent, RowsCollection rows, bool expand) 
            : base(parent)
        {            
            this.expand = expand;
            this.rows = rows;

            this.PrimaryContext = rows;           

            this.InitializeImage();
            
        }        

        private void InitializeImage()
        {
            if (this.expand)
            {
                if (null == ExpandCollapseButtonUIElement.expandImage)
                    ExpandCollapseButtonUIElement.expandImage = this.GetImage();

                this.Image = ExpandCollapseButtonUIElement.expandImage;
            }
            else
            {
                if (null == ExpandCollapseButtonUIElement.collapseImage)
                    ExpandCollapseButtonUIElement.collapseImage = this.GetImage();

                this.Image = ExpandCollapseButtonUIElement.collapseImage;
            }
        }

        private Image GetImage()
        {
            string imageName = this.expand 
                ? "ExpandAll"
                : "CollapseAll";

            string resourceName = String.Format("WinGrid_ExpandAllButton_CS.Images.{0}.png", imageName);

            Stream stream = this.GetType().Assembly.GetManifestResourceStream(resourceName);
            if (null == stream)
            {
                Debug.Fail("Failed to find the resource stream. Make sure the resource name is correct and that the image file is marked as an EmbeddedResource.");                    
                return null;
            }

            return Image.FromStream(stream);
        }

        protected override bool ButtonClick()
        {
            RowsCollection rows = this.rows;
            if (null != rows)
            {
                if (this.expand)
                    rows.ExpandAll(true);
                else
                    rows.CollapseAll(true);

                return true;
            }
            return false;
        }        
    }
}
